Subject: Re: bug#7782: 24.0.50; 24.0.50: set-scroll-bar-mode missing under non-GUI environments

From: Lars Ingebrigtsen <[email-masked]>
Date: Sat, 04 Dec 2021 21:29:09 +0100

Stefan Monnier <[email-masked]> writes:

>> In a without-x build, neither tool-bar-mode nor set-scroll-bar-mode is
>> defined.
>
> That's the problem.  I know Emacs has many such things already, but
> I think these are all bugs: I think we should adopt a convention that
> functions/variables should either be specific to one particular kind of
> display, or be display-independent.  Since (set-)scroll-bar-mode is not
> specific to one particular kind of display (it is shared by w32, X11,
> and ns), it should exist independently from any particular display.

I think that makes sense conceptually, but I think that people that do
a --without-x build do so for a particular reason: They want to have as
lean an Emacs as possible.  (Otherwise -- why bother?)

So we could certainly do this (and similarly for a bunch of other
stuff):

diff --git a/lisp/loadup.el b/lisp/loadup.el
index ed1570e778..b7e63cc656 100644
--- a/lisp/loadup.el
+++ b/lisp/loadup.el
@@ -260,8 +260,7 @@
 (load "jit-lock")
 
 (load "mouse")
-(if (boundp 'x-toolkit-scroll-bars)
-    (load "scroll-bar"))
+(load "scroll-bar")
 (load "select")
 (load "emacs-lisp/timer")
 (load "emacs-lisp/easymenu")

But I'm not sure we'd be doing anybody any favours.

Does anybody have an opinion here?

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no